unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, SQLDB, DB, SQLite3Conn, Forms, Controls, Graphics, Dialogs,
  DBCtrls, DBGrids, ExtCtrls, StdCtrls, ZConnection, ZDataset;

type

  { TForm1 }

  TForm1 = class(TForm)
    ButtonRemove: TButton;
    DataSource: TDataSource;
    DBGrid: TDBGrid;
    Connection: TZConnection;
    Query: TZQuery;
    procedure ButtonRemoveClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    procedure FillEntries;
    function  IsPrime(ANumber: Integer): Boolean;
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
var
  LFileName: String;
begin
  LFileName := GetCurrentDir + PathDelim + 'test.sql';
  if FileExists(LFileName) then
    DeleteFile(LFileName);

  Connection.Database := LFileName;
  Connection.LibraryLocation := GetCurrentDir + PathDelim + 'sqlite3.dll';
  Connection.HostName := 'localhost';
  Connection.Protocol := 'sqlite';
  Connection.AutoCommit := False;
  Connection.Connected := True;

  Query.SQL.Text:=
    'CREATE TABLE test (' +
    'id INTEGER PRIMARY KEY AUTOINCREMENT, ' +
    'number INTEGER);';
  Query.ExecSQL;

  Query.SQL.Text := 'SELECT id, number FROM test;';
  Query.Open;

  FillEntries;
end;

procedure TForm1.ButtonRemoveClick(Sender: TObject);
begin
  Query.First;
  while not Query.EOF do
  begin
    if not IsPrime(Query.Fields[1].AsInteger) then
      Query.Delete
    else
      Query.Next;
  end;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  Query.ApplyUpdates;
end;

procedure TForm1.FillEntries;
var
  i: Integer;
begin
  for i := 1 to 100 do
  begin
    Query.Append;
    Query.Fields[1].AsInteger := i;
    Query.Post;
  end;
  Query.First;
end;

function TForm1.IsPrime(ANumber: Integer): Boolean;
var
  i: Integer;
begin
  for i := 2 to Round(Sqrt(ANumber)) do
    if ANumber mod i = 0 then
      Exit(False);
  Result := True;
end;

end.

